@echo off
setlocal ENABLEEXTENSIONS DISABLEDELAYEDEXPANSION
pushd "%~dp0"
set log=MinGW EDuke32 Setup Helper.log
set tee=tee.exe -a "%log%"
echo MinGW EDuke32 Setup Helper started at: %date% %time% | %tee%

:path
set mingw=C:\MinGW\bin
set msys=C:\MinGW\msys\1.0\bin

for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo PATH backup: %pathtemp:"=% >>"%log%"

:pathmingw
for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo %pathtemp% | grep.exe -q -i "%mingw:\=\\%"
if "%ERRORLEVEL%"=="0" goto pathmingw_end
echo Adding MinGW to PATH.
echo Adding MinGW to PATH: %pathtemp:"=%;%mingw% >>"%log%"
setenv.exe -m PATH "%pathtemp:"=%;%mingw%"
set PATH=%PATH%;%mingw%
:pathmingw_end

:pathmsys
for /f "tokens=*" %%G in ('setenv.exe -m PATH') do set pathtemp=%%~G
echo %pathtemp% | grep.exe -q -i "%msys:\=\\%"
if "%ERRORLEVEL%"=="0" goto pathmsys_end
echo Adding MSYS to PATH.
echo Adding MSYS to PATH: %pathtemp:"=%;%msys% >>"%log%"
setenv.exe -m PATH "%pathtemp:"=%;%msys%"
set PATH=%PATH%;%msys%
:pathmsys_end

:mingw
if not exist "%mingw%" echo MinGW not detected! http://wiki.eduke32.com/wiki/Building_EDuke32_on_Windows | %tee%

:nasm
for %%G in (nasm.exe) do set nasm=%%~$PATH:G
if "%nasm%"=="" echo NASM not detected! http://www.nasm.us/ | %tee%
echo.

:mingwupdate
for %%G in (mingw-get.exe) do set mingwget=%%~$PATH:G
if "%mingwget%"=="" (
echo Fatal Error: MinGW-Get not detected! | %tee%
goto mingwupdate_end
)

mingw-get.exe update 2>&1 | %tee%

for %%G in (mingw-get mingw32-gcc binutils mingw-runtime mpc mpfr pthreads libgomp libssp libintl libiconv gcc-c++ gcc-core gdb libexpat libgcc libgmp libmpc libmpfr libssp libstdc++ mingwrt w32api msys-bash msys-coreutils msys-make msys-core msys-regex msys-termcap mingw-utils) do (
mingw-get.exe install %%~G 2>&1 | %tee%
mingw-get.exe upgrade %%~G 2>&1 | %tee%
)
:mingwupdate_end

:deletemingwmake
if exist "%msys%\make.exe" if exist "%mingw%\make.exe" del /f /q "%mingw%\make.exe"

:end
echo MinGW EDuke32 Setup Helper finished at: %date% %time% | %tee%
echo. | %tee%
popd
endlocal

pause
